import {
  Actions,
  ActionType,
} from './auth.action';

import {
  State,
  initialState,
} from './auth.state';

export function reducer(state: State = initialState, action: Actions): State {
  switch (action.type) {
    case ActionType.SigninSuccess: {
      return {
        signined: true,
        domainMember: action.payload.domainMember,
      };
    }

    case ActionType.SigninFailure: {
      return {
        signined: false,
        domainMember: null,
      };
    }

    case ActionType.SigninCookieSuccess: {
      return {
        signined: true,
        domainMember: action.payload,
      };
    }

    case ActionType.SigninCookieFailure: {
      return {
        signined: false,
        domainMember: null,
      };
    }

    case ActionType.SignoutSuccess: {
      return {
        signined: false,
        domainMember: null,
      };
    }

    case ActionType.SignoutFailure: {
      return {
        ...state,
      };
    }

    default: {
      return state;
    }
  }
}
